﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;

namespace XamDataChartDynamicLegend
{
    public class DataUtil
    {
        #region private memebers

        #region private fields

        private static ObservableCollection<Purchase> purchases;

        #endregion // private fields

        #region private methods

        private static ObservableCollection<Purchase> CreatePurchases()
        {
            ObservableCollection<Purchase> p = new ObservableCollection<Purchase>();
            Random randNum = new Random();
            for (int i = 0; i < 2; i++)
            {
                double purchaseAmt = randNum.NextDouble() * 100;
                p.Add(new Purchase
                {
                    CustomerID = i.ToString(),
                    PurchaseAmount = purchaseAmt,
                    Tax = purchaseAmt * .07,
                    PurchaseDate = DateTime.Today.Date.AddDays(-1 * i)
                });
            }

            return p;
        }

        #endregion // private methods

        #endregion // private members

        #region public members

        #region public properties

        public static ObservableCollection<Purchase> Purchases
        {
            get
            {
                if (purchases == null)
                    purchases = CreatePurchases();

                return purchases;
            }
        }

        #endregion // public properties

        #endregion // public members
    }

    public class Purchase : INotifyPropertyChanged
    {
        #region private fields

        private string customerID;
        private DateTime purchaseDate;
        private double purchaseAmount;
        private double tax;

        #endregion // private fields

        #region public properties

        public string CustomerID
        {
            get
            {
                return this.customerID;
            }
            set
            {
                if (this.customerID != value)
                {
                    this.customerID = value;
                    OnPropertyChanged("CustomerID");
                }
            }
        }

        public DateTime PurchaseDate
        {
            get
            {
                return this.purchaseDate;
            }
            set
            {
                if (this.purchaseDate != value)
                {
                    this.purchaseDate = value;
                    OnPropertyChanged("PurchaseDate");
                }
            }
        }

        public Double PurchaseAmount
        {
            get
            {
                return this.purchaseAmount;
            }
            set
            {
                if (this.purchaseAmount != value)
                {
                    this.purchaseAmount = value;
                    OnPropertyChanged("PurchaseAmount");
                }
            }
        }

        public Double Tax
        {
            get
            {
                return this.tax;
            }
            set
            {
                if (this.tax != value)
                {
                    this.tax = value;
                    OnPropertyChanged("Tax");
                }
            }
        }

        #endregion // public properties

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        #endregion
    }
}
   